From a7d00e82810c09c65c1d9256aeea363a9c4ed3fe Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 06 2020 23:53:33 +0000
Subject: [PATCH 106/2232] Test &R passed from Rust to C++


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index d1b33c2..e21a62c 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -24,7 +24,7 @@ pub mod ffi {
         fn c_take_shared(shared: Shared);
         fn c_take_box(r: Box<R>);
         fn c_take_unique_ptr(c: UniquePtr<C>);
-        //TODO fn c_take_ref_r(r: &R);
+        fn c_take_ref_r(r: &R);
         fn c_take_ref_c(c: &C);
         fn c_take_str(s: &str);
         fn c_take_rust_string(s: String);
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index adbf945..7b77c07 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -3,6 +3,7 @@
 
 extern "C" void cxx_test_suite_set_correct();
 extern "C" tests::R *cxx_test_suite_get_box();
+extern "C" bool cxx_test_suite_r_is_correct(const tests::R *);
 
 namespace tests {
 
@@ -48,8 +49,9 @@ void c_take_shared(Shared shared) {
 }
 
 void c_take_box(rust::Box<R> r) {
-  (void)r;
-  cxx_test_suite_set_correct();
+  if (cxx_test_suite_r_is_correct(&*r)) {
+    cxx_test_suite_set_correct();
+  }
 }
 
 void c_take_unique_ptr(std::unique_ptr<C> c) {
@@ -58,7 +60,11 @@ void c_take_unique_ptr(std::unique_ptr<C> c) {
   }
 }
 
-void c_take_ref_r(const R &r) { (void)r; }
+void c_take_ref_r(const R &r) {
+  if (cxx_test_suite_r_is_correct(&r)) {
+    cxx_test_suite_set_correct();
+  }
+}
 
 void c_take_ref_c(const C &c) {
   if (c.get() == 2020) {
diff --git a/tests/test.rs b/tests/test.rs
index eb06481..a30aefb 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -75,3 +75,8 @@ fn test_c_call_r() {
 extern "C" fn cxx_test_suite_get_box() -> *mut cxx_test_suite::R {
     Box::into_raw(Box::new(2020usize))
 }
+
+#[no_mangle]
+unsafe extern "C" fn cxx_test_suite_r_is_correct(r: *const cxx_test_suite::R) -> bool {
+    *r == 2020
+}

